﻿using STcpHelper;

namespace TAPClient
{
    internal class Program
    {
        static void Main(string[] args)
        {
            STcpClient client = new STcpClient();
            client.ErrorCallback += ((sender, ex) => { Console.WriteLine($"[ERR] {ex.Message}"); });
            client.MessageCallback += ((sender, msg) => { Console.WriteLine(msg); });
            client.Connect("127.0.0.1", 8207);

            while (true)
            {
                string input = Console.ReadLine();
                switch (input.ToLower())
                {
                    case "":
                        break;
                    case "rcl":
                        client.RequireClientList();
                        break;
                    case "df":
                        Console.Write("File path: ");
                        string path = Console.ReadLine();
                        client.RequireFile(path);
                        break;
                    case "zoo":
                        client.RequireZoo();
                        break;
                    default:
                        client.SendMessage(input);
                        break;
                }

            }
        }
    }
}